require "ffxiv_scraper/version"
require 'open-uri'
require 'nokogiri'

module FFXIVScraper
  module Lodestone
    module Common
      FFXIV_BASE_DOMAIN = "finalfantasyxiv.com".freeze
      LODESTONE_PATH = "/lodestone".freeze
      LANG = {ja: 'jp', na: 'na', eu:'eu', fr: 'fr', de: 'de'}.map(&:freeze).to_h.freeze

      def set_locale(lang = :ja)
        @lang = lang
      end

      def get_base_url
        return "https://#{LANG[@lang]}.#{FFXIV_BASE_DOMAIN}" 
      end
      
      def get_lodestone_url
        return "https://#{LANG[@lang]}.#{FFXIV_BASE_DOMAIN}#{LODESTONE_PATH}"
      end

      def open_html(url)
        begin
          charset = nil
          html = open(url) do |f|
            charset = f.charset
            f.read
          end      
          Nokogiri::HTML.parse(html, nil, charset)
        rescue  => exception
          raise "url open exception. url [" << url << "]" << ", message [" << exception.message << "]"
        end
      end
    end
  end
end
